#ifndef _KGR_PATCH_BSC1180030_H
#define _KGR_PATCH_BSC1180030_H

#if IS_ENABLED(CONFIG_HID)

int kgr_patch_bsc1180030_hid_input_init(void);
static inline void kgr_patch_bsc1180030_hid_input_cleanup(void) {}

int kgr_patch_bsc1180030_hid_multitouch_init(void);
void kgr_patch_bsc1180030_hid_multitouch_cleanup(void);

int kgr_patch_bsc1180030_init(void);
void kgr_patch_bsc1180030_cleanup(void);


struct hid_input;
struct hid_field;
struct hid_usage;
struct hid_device;

void kgrp_hidinput_configure_usage(struct hid_input *hidinput, struct hid_field *field,
				     struct hid_usage *usage);

int kgrp_mt_input_mapping(struct hid_device *hdev, struct hid_input *hi,
		struct hid_field *field, struct hid_usage *usage,
		unsigned long **bit, int *max);

#define KGR_PATCH_BSC1180030_FUNCS				\
	KGR_PATCH(hidinput_configure_usage,			\
		  kgrp_hidinput_configure_usage),		\
	KGR_PATCH_OBJ(mt_input_mapping, kgrp_mt_input_mapping,	\
		      "hid_multitouch"),			\

#else /* !IS_ENABLED(CONFIG_HID) */

static inline int kgr_patch_bsc1180030_init(void) { return 0; }

static inline void kgr_patch_bsc1180030_cleanup(void) {}

#define KGR_PATCH_BSC1180030_FUNCS

#endif /* IS_ENABLED(CONFIG_HID) */
#endif /* _KGR_PATCH_BSC1180030_H */
